BeerOverflow.Web/Controllers/BreweryController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using BeerOverflow.Services.Services;
using BeerOverflow.Web.Mappers;
using BeerOverflow.Web.Models;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;

namespace BeerOverflow.Web.Controllers
{
    public class BreweryController : Controller
    {
        private readonly IBreweryServices breweryServices;
        private readonly ICountryServices countryServices;
        public BreweryController(IBreweryServices breweryServices, ICountryServices countryServices)
        {
            this.breweryServices = breweryServices;
            this.countryServices = countryServices;
        }

        [HttpGet]
        public IActionResult CreateBrewery()
        {
            BreweryViewModel viewModel = new BreweryViewModel();

           // viewModel.Countries 
                ViewBag.Countries = countryServices.GetAllCountries().MapFrom().ToList();

            return View();
        }

        [HttpPost]
        public IActionResult CreateBrewery(BreweryViewModel breweryVM)
        {
            this.breweryServices.CreateBrewery(breweryVM.MapFrom());
            return RedirectToAction("ListBreweries");
        }

        [HttpGet]
        public IActionResult ListBreweries()
        {
            var breweries = this.breweryServices.GetAllBreweries().MapFrom().ToList();
            return View(breweries);
        }

        [HttpGet]
        public IActionResult DeleteBrewery()
        {
            return View();
        }

        [HttpPost]
        public IActionResult DeleteBrewery(string name)
        {
            this.breweryServices.DeleteBrewery(name);

            return RedirectToAction("ListBreweries");
        }

        [HttpGet]
        public IActionResult EditBrewery(Guid id)
        {
            var brewery = this.breweryServices.GetBrewery(id).MapFrom();

            return View(brewery);
        }

        [HttpPost]
        public IActionResult EditBrewery(Guid id, string name)
        {
            breweryServices.EditBrewery(id, name);
            return RedirectToAction("ListBreweries");
        }

        [HttpGet]
        public IActionResult Details(Guid id)
        {
          var brewery = this.breweryServices.GetBrewery(id).MapFrom();
            return View(brewery);
        }
    }
}

BeerOverflow.Web/Controllers/StyleController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using BeerOverflow.Models;
using BeerOverflow.Services.Contracts;
using BeerOverflow.Web.Mappers;
using BeerOverflow.Web.Models;
using Microsoft.AspNetCore.Mvc;

namespace BeerOverflow.Web.Controllers
{
    public class StyleController : Controller
    {
        private readonly IStyleServices service;
        public StyleController(IStyleServices service)
        {
            this.service = service;
        }

        [HttpGet]
        public IActionResult ListStyles(StyleSearchModel model)
        {
            var styleList = service.GetAllStyles().ToList().MapFrom();

            if (!string.IsNullOrEmpty(model.Searcher))
            {
                styleList = styleList
                    .Where(s => s.Name.Contains(model.Searcher))
                    .ToList();
            }

            model.Styles = styleList;
            return View(model);
        }

        [HttpGet]
        public IActionResult CreateStyle()
        {
            return View();
        }

        [HttpPost]
        public IActionResult CreateStyle(StyleViewModel styleViewModel)
        {
            var styleDTO = styleViewModel.MapFrom();

            service.CreateStyle(styleDTO);

            return RedirectToAction("ListStyles");
        }

        [HttpGet]
        public IActionResult DeleteStyle (Guid id)
        {
            service.DeleteStyle(id);


            return RedirectToAction("ListStyles");
        }

        [HttpGet]
        public IActionResult Details(Guid id)
        {
            var style = this.service.GetStyle(id).MapFrom();
            return View(style);
        }


    }
}

BeerOverflow.Web/Controllers/UserController.cs
using BeerOverflow.Services.Contracts;
using BeerOverflow.Services.Services;
using BeerOverflow.Web.Models;
using Microsoft.AspNetCore.Mvc;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace BeerOverflow.Web.Controllers
{
    public class UserController: Controller
    {
        private readonly IBeerServices beerService;
        private readonly ICountryServices countryServices;
        private readonly IBreweryServices breweryServices;
        private readonly IStyleServices styleServices;
        private readonly IUserServices userServices;
        public UserController(IBeerServices beerService, ICountryServices countryServices, IBreweryServices breweryServices, IStyleServices styleServices, IUserServices userServices)
        {
            this.beerService = beerService;
            this.countryServices = countryServices;
            this.breweryServices = breweryServices;
            this.styleServices = styleServices;
            this.userServices = userServices;
        }
        [HttpGet]
        public IActionResult Details(string username)
        {
            var user = this.userServices.GetUser(username);

            return View(user);
        }

        [HttpGet]
        public IActionResult ListUsers()
        {
            var users = this.userServices.GetAllUsers();

            var allUsers = new AllUsersViewModel();
            allUsers.Users = users.ToList();
            return View(allUsers);
        }

        [HttpGet]
        public IActionResult DeleteUser(Guid id)
        {
            this.userServices.DeleteUser(id);

            return RedirectToAction("ListUsers");
        }

        [HttpGet]
        public IActionResult BanUser(Guid id)
        {
            this.userServices.BanUser(id);

            return RedirectToAction("ListUsers");
        }
    }
}

BeerOverflow.Web/Views/Shared/_Carousel.cshtml
<div id="myCarousel" class="carousel slide" data-ride="carousel">
    <ol class="carousel-indicators">
        <li data-target="#myCarousel" data-slide-to="0" class=""></li>
        <li data-target="#myCarousel" data-slide-to="1" class=""></li>
        <li data-target="#myCarousel" data-slide-to="2" class="active"></li>
    </ol>
    <div class="carousel-inner">
        <div class="carousel-item">
            <img class="first-slide" src="~/Images/Carousell/11.gif" alt="First slide">
            <div class="container">
            </div>
        </div>
        <div class="carousel-item">
            <img class="second-slide" src="~/Images/Carousell/11.gif" alt="Second slide">
            <div class="container">
            </div>
        </div>
        <div class="carousel-item active">
            <img class="third-slide" src="~/Images/Carousell/11.gif" alt="Third slide">
            <div class="container">
            </div>
        </div>
    </div>
    <a class="carousel-control-prev" href="#myCarousel" role="button" data-slide="prev">
        <span class="carousel-control-prev-icon" aria-hidden="true"></span>
        <span class="sr-only">Previous</span>
    </a>
    <a class="carousel-control-next" href="#myCarousel" role="button" data-slide="next">
        <span class="carousel-control-next-icon" aria-hidden="true"></span>
        <span class="sr-only">Next</span>
    </a>
</div>

BeerOverflow.Web/Views/Shared/_Layout.cshtml
<!DOCTYPE html>

<html lang="en">
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"]BeerOverflow</title>

    <meta name="viewport" content="width=device-width" />
    <link rel="stylesheet" type="text/css" href="~/css/dataTableStyle.css" />
    <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.min.css" />
    <link rel="stylesheet" href="~/css/site.css" />
</head>

<body>
    <header>
        <nav id="navbar" class="navbar fixed-top  navbar-expand-sm navbar-toggleable-sm navbar-light  box-shadow mb-3" style="background-color:#303030;">
            <div class="container">
                <button class="navbar-toggler" style="" type="button" data-toggle="collapse" data-target=".navbar-collapse" aria-controls="navbarSupportedContent"
                        aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="navbar-collapse collapse d-sm-inline-flex flex-sm-row-reverse">
                    <partial name="_LoginPartial" />

                    <ul class="navbar-nav flex-grow-1">
                        <li class="nav-item">
                            <a class="nav-link " style="color:#b58900" asp-area="" asp-controller="Home" asp-action="Index">Beer Overflow</a>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" style="background-color:#303030;color:#b58900" data-toggle="dropdown" role="button" aria-haspopup="true" aria-expanded="false">Beers</a>
                            <div class="dropdown-menu" style="">
                                @if (User.Identity.IsAuthenticated)
                                {
                                    <a class="dropdown-item" style="background-color: white " asp-area="" asp-controller="Beer" asp-action="CreateBeer">Create Beer</a>
                                }
                                <a class="dropdown-item" style="background-color:white " asp-area="" asp-controller="Beer" asp-action="ListBeers">Show All Beers</a>
                                @if (User.Identity.IsAuthenticated)
                                {
                                    <a class="dropdown-item" style="background-color:white " asp-area="" asp-controller="Beer" asp-action="DeleteBeer">Delete Beer</a>
                                }

                            </div>
                        </li>

                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" style="background-color:#303030;color:#b58900" data-toggle="dropdown" href="#" role="button" aria-haspopup="true" aria-expanded="false">Breweries</a>
                            <div class="dropdown-menu" style="">
                                @if (User.Identity.IsAuthenticated)
                                {
                                    <a class="dropdown-item" style="background-color: white " asp-area="" asp-controller="Brewery" asp-action="CreateBrewery">Create Brewery</a>
                                }
                                <a class="dropdown-item" style="background-color:white " asp-area="" asp-controller="Brewery" asp-action="ListBreweries">Show All Breweries</a>

                                @if (User.Identity.IsAuthenticated)
                                {
                                    <a class="dropdown-item" style="background-color:white " asp-area="" asp-controller="Brewery" asp-action="DeleteBrewery">Delete Brewery</a>
                                }

                            </div>
                        </li>

                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" style="background-color:#303030;color:#b58900" data-toggle="dropdown" href="#" role="button" aria-haspopup="true" aria-expanded="false">Countries</a>
                            <div class="dropdown-menu" style="">
                                @if (User.Identity.IsAuthenticated)
                                {
                                    <a class="dropdown-item" style="background-color:white " asp-area="" asp-controller="Country" asp-action="CreateCountry">Create Country</a>
                                }
                                <a class="dropdown-item" style="background-color:white " asp-area="" asp-controller="Country" asp-action="ListCountry">Show All Countries</a>
                            </div>
                        </li>

                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" style="background-color:#303030;color:#b58900" data-toggle="dropdown" href="#" role="button" aria-haspopup="true" aria-expanded="false">Styles</a>
                            <div class="dropdown-menu" style="">
                                @if (User.Identity.IsAuthenticated)
                                {
                                    <a class="dropdown-item" style="background-color:white " asp-area="" asp-controller="Style" asp-action="CreateStyle">Create Style</a>
                                }
                                <a class="dropdown-item" style="background-color:white " asp-area="" asp-controller="Style" asp-action="ListStyles">Show All Styles</a>
                            </div>
                        </li>

                        @if (User.Identity.IsAuthenticated)
                        {
                            <li class="nav-item">
                                <a style="color:white"  class="nav-link " asp-area="" asp-controller="User" asp-action="Details" asp-route-username="@User.Identity.Name">Profile</a>
                            </li>
                        }
                        @if (User.IsInRole("Admin"))
                        {
                            <li class="nav-item">
                                <a style="color:white"  class="nav-link " asp-area="" asp-controller="User" asp-action="ListUsers">Users</a>
                            </li>
                        }
                    </ul>
                </div>
            </div>
        </nav>
    </header>
    <div class="container">
        <main role="main" class="pb-3">
            @RenderBody()
        </main>
    </div>

    <footer class="footer text-muted">
        <div class="container">
            &copy; 2020 - BeerOverflow - <a asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
        </div>
    </footer>
    <script src="~/lib/jquery/dist/jquery.min.js"></script>
    <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
    <script src="~/js/site.js" asp-append-version="true"></script>
    <script type="text/javascript" charset="utf-8" src="~/js/jquerydatatable.js"></script>
    <script type="text/javascript" charset="utf-8" src="~/js/datatable.js"></script>
    @RenderSection("Scripts", required: false)
</body>
</html>

BeerOverflow.Web/Views/Shared/_List.cshtml
@model List<BeerViewModel>
@{ var list = Model;}



<div class="row" style="margin-bottom:100px;">

    <div class="col-lg-4" >

        <center>
            <img class="rounded-circle" src=@Model[0].ImageURL alt="Generic placeholder image" width="300" height="300">
            <br>
            <h4 style="color:white; ">@Model[0].Name.ToUpper()</h4>
            <p>@Model[0].Description</p>
            <p><a  class="btn btn-secondary" style="background-color:#b58900; border:none" role="button" asp-controller="Beer" asp-action="Details" asp-route-id="@Model[0].Id">View details »</a></p>
        </center>
    </div><!-- /.col-lg-4 -->
    <div class="col-lg-4">
        <center>
            <img class="rounded-circle" src=@Model[1].ImageURL alt="Generic placeholder image" width="300" height="300">
            <br>
            <h4 style="color:white">@Model[1].Name.ToUpper()</h4>
            <p>@Model[1].Description</p>
            <p><a class="btn btn-secondary" role="button" style="background-color:#b58900; border:none" asp-controller="Beer" asp-action="Details" asp-route-id="@Model[1].Id">View details »</a></p>
        </center>
    </div><!-- /.col-lg-4 -->
    <div class="col-lg-4">
        <center>
            <img class="rounded-circle" src=@Model[2].ImageURL alt="Generic placeholder image" width="300" height="300">
            <br>
            <h4 style="color:white">@Model[2].Name.ToUpper()</h4>
            <p>@Model[2].Description</p>
            <p><a  class="btn btn-secondary" role="button" style="background-color:#b58900; border:none" asp-controller="Beer" asp-action="Details" asp-route-id="@Model[2].Id">View details »</a></p>
        </center>
    </div><!-- /.col-lg-4 -->
</div>